/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2007-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: chip_asm.inc 394 2009-09-15 07:08:25Z ertl-honda $
 */

#ifndef TOPPERS_CHIP_ASM_INC
#define TOPPERS_CHIP_ASM_INC

#include "arm_armcc/common/core_asm.inc"

	MACRO
$label my_core_index $re_reg
	mrc p15, 0, $re_reg, c0, c0, 5 /* ץåIDμ */
	and $re_reg, $re_reg, #0x0f    /* 4bitΤͭ   */
	MEND

#ifdef USE_THREAD_ID_PCB
	MACRO
$label my_pcb $re_reg, $sc_reg1
	mrc p15, 0, $re_reg, c13, c0, 4
	MEND
#else  /* USE_THREAD_ID_PCB */
	MACRO
$label my_pcb $re_reg, $sc_reg1
	mrc p15, 0, $re_reg, c0, c0, 5 /* ץåIDμ */
	and $sc_reg1, $re_reg, #0x0f   /* 4bitΤͭ   */
	ldr $re_reg, =p_pcb_table
	ldr $re_reg, [$re_reg, $sc_reg1, lsl #2]
	MEND
#endif /* USE_THREAD_ID_PCB */

	MACRO
$label my_istkpt $re_reg, $sc_reg1
	mrc p15, 0, $re_reg, c0, c0, 5 /* ץåIDμ */
	and $sc_reg1, $re_reg, #0x0f   /* 4bitΤͭ   */
	ldr $re_reg, =_kernel_istkpt_table
	ldr $re_reg, [$re_reg, $sc_reg1, lsl #2]
	MEND

	MACRO
$label toppers_asm_custom_idle
	wfi
	msr   cpsr_cxsf, #(CPSR_SVC :OR: CPSR_ALWAYS_SET) /* ߵ(ƥ⡼) */
	msr   cpsr_cxsf, #(CPSR_SVC :OR: CPSR_CPULOCK :OR: CPSR_ALWAYS_SET) /* CPUå(ƥ⡼) */
	MEND

#endif /* TOPPERS_CHIP_ASM_INC */
