/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2007-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: spin_lock.h 771 2011-01-21 02:06:07Z ertl-honda $
 */

/*
 *		ԥåǽ
 */

#ifndef TOPPERS_SPIN_LOCK_H
#define TOPPERS_SPIN_LOCK_H

#if TTYPE_SPN == NATIVE_SPN

/*
 *  ԥå֥å
 */
typedef struct spin_lock_initialization_block {
	ATR			spnatr;			/* ԥå° */
} SPNINIB;

/*
 *  ԥå֥å
 */
typedef struct spin_lock_control_block {
	SPNLOCK		spn_lock;		/* åо */
	const SPNINIB *p_spninib;	/* ֥åؤΥݥ */
	bool_t		lock_flg;		/* ԥåθߤΥå */
} SPNCB;

#else /* TTYPE_SPN == EMULATE_SPN */

#if TTYPE_KLOCK == F_KLOCK
#error Can not use EMULATE_SPN with F_KLOCK. Use NATIVE_SPN.
#endif /* TTYPE_KLOCK == F_KLOCK */

/*
 *  ԥå֥å
 */
typedef struct spin_lock_initialization_block {
	ATR			spnatr;			/* ԥå° */
#if TTYPE_KLOCK == P_KLOCK
	LOCK		*p_obj_lock;		/* åؤΥݥ */
#endif /* TTYPE_KLOCK == P_KLOCK */
} SPNINIB;

/*
 *  ԥå֥å
 */
typedef struct spin_lock_control_block {
	QUEUE		dummy;			/* ¾Ʊ֥ȤƱޥȤΥߡ */        
	const SPNINIB *p_spninib;	/* ֥åؤΥݥ */
	bool_t		lock_flg;		/* ԥåθߤΥå */
} SPNCB;

#endif /* TTYPE_SPN == EMULATE_SPN */

/*
 *  ԥå֥åΥꥢkernel_cfg.c
 */
extern const SPNINIB	spninib_table[];

/*
 *  ԥå֥åؤΥݥ󥿥ơ֥kernel_cfg.c
 */
extern SPNCB* const	p_spncb_table[];

/*
 *  ԥåIDκ͡kernel_cfg.c
 */
extern const ID	tmax_spnid;

/*
 *  ԥåǽν
 */
extern void	initialize_spin_lock(void);

/*
 *  ԥåζPCBlockspnidоݤˤ
 */
extern void	force_unlock_spin(PCB *my_p_pcb);

#endif /* TOPPERS_SPIN_LOCK_H */
